Page MenuHomeFreeBSD

Add ports for an i386 external GCC toolchain.
ClosedPublic

Authored by jhb on Jul 11 2018, 4:36 PM.

Details

Summary
  • devel/binutils: Remove i386 a.out linker scripts when building i386-binutils or a base/binutils that targets i386.
  • devel/i386-{binutils,gcc,xtoolchain}: New ports. i386-gcc excludes GCC's internal float.h for the same reasons as described in D16073.
Test Plan
  • still need to do an actual buildworld though I expect it to work fine

Diff Detail

Repository
rP FreeBSD ports repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

jhb created this revision.Jul 11 2018, 4:36 PM
lwhsu added a subscriber: lwhsu.Jul 12 2018, 12:59 AM
lwhsu added inline comments.
devel/binutils/Makefile
122 ↗(On Diff #45176)

This removes i386bsd linker scripts everywhere, not just "i386-binutils or a base/binutils that targets i386."
Is it intended?

jhb added inline comments.Jul 12 2018, 4:11 PM
devel/binutils/Makefile
122 ↗(On Diff #45176)

devel/binutils doesn't define PGKNAMEPREFIX and this clause is in the .else after that test, so this doesn't impact devel/binutils. The only other binutils ports which specify i386 as a target are base/binutils (with out of tree patches) and devel/i386-binutils.

(The post-install target is fairly messy IMO due to all the conditionals for various slave ports)

lwhsu added inline comments.Jul 12 2018, 4:26 PM
devel/binutils/Makefile
122 ↗(On Diff #45176)

Oh right, I was thinking it will affect other <arch>-binutils also have PGKNAMEPREFIX defined but forgot that they will not install i386bsd linker scripts. Sorry for the noise.

jhb added inline comments.Jul 12 2018, 4:38 PM
devel/binutils/Makefile
122 ↗(On Diff #45176)

No problem.

jhb added a comment.Jul 12 2018, 6:42 PM

Update: I've done a buildworld (though newer gcc is pickier about some things that I need to post some src patches for review) and have built base/binutils and base/gcc using this as a CROSS_TOOLCHAIN.

bapt accepted this revision.Jul 24 2018, 4:27 PM
This revision is now accepted and ready to land.Jul 24 2018, 4:27 PM
jhb updated this revision to Diff 45837.Jul 25 2018, 5:32 PM
  • Add i386 to the list of archs to delete float.h in powerpc64-gcc/Makefile.
This revision now requires review to proceed.Jul 25 2018, 5:32 PM
This revision was not accepted when it landed; it landed in state Needs Review.Jul 25 2018, 5:47 PM
This revision was automatically updated to reflect the committed changes.